// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <goocanvasmm/ellipse.h>
#include <goocanvasmm/private/ellipse_p.h>


/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasellipse.h>


namespace Goocanvas
{

//TODO: Reimplement the C _new function:
Ellipse::Ellipse(double center_x, double center_y, double radius_x, double radius_y)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemSimple(Glib::ConstructParams(ellipse_class_.init(), "center_x",center_x,"center_y",center_y,"radius_x",radius_x,"radius_y",radius_y, static_cast<char*>(0)))
{
}

} //namespace GooCanvas

namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Goocanvas::Ellipse> wrap(GooCanvasEllipse* object, bool take_copy)
{
  return Glib::RefPtr<Goocanvas::Ellipse>( dynamic_cast<Goocanvas::Ellipse*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Goocanvas
{


/* The *_Class implementation: */

const Glib::Class& Ellipse_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Ellipse_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(goo_canvas_ellipse_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void Ellipse_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* Ellipse_Class::wrap_new(GObject* object)
{
  return new Ellipse((GooCanvasEllipse*)object);
}


/* The implementation: */

GooCanvasEllipse* Ellipse::gobj_copy()
{
  reference();
  return gobj();
}

Ellipse::Ellipse(const Glib::ConstructParams& construct_params)
:
  Goocanvas::ItemSimple(construct_params)
{

}

Ellipse::Ellipse(GooCanvasEllipse* castitem)
:
  Goocanvas::ItemSimple((GooCanvasItemSimple*)(castitem))
{}


Ellipse::Ellipse(Ellipse&& src) noexcept
: Goocanvas::ItemSimple(std::move(src))
{}

Ellipse& Ellipse::operator=(Ellipse&& src) noexcept
{
  Goocanvas::ItemSimple::operator=(std::move(src));
  return *this;
}

Ellipse::~Ellipse() noexcept
{}


Ellipse::CppClassType Ellipse::ellipse_class_; // initialize static member

GType Ellipse::get_type()
{
  return ellipse_class_.init().get_type();
}


GType Ellipse::get_base_type()
{
  return goo_canvas_ellipse_get_type();
}


Glib::RefPtr<Ellipse> Ellipse::create(double center_x, double center_y, double radius_x, double radius_y)
{
  return Glib::RefPtr<Ellipse>( new Ellipse(center_x, center_y, radius_x, radius_y) );
}


Glib::PropertyProxy< double > Ellipse::property_center_x() 
{
  return Glib::PropertyProxy< double >(this, "center-x");
}

Glib::PropertyProxy_ReadOnly< double > Ellipse::property_center_x() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "center-x");
}

Glib::PropertyProxy< double > Ellipse::property_center_y() 
{
  return Glib::PropertyProxy< double >(this, "center-y");
}

Glib::PropertyProxy_ReadOnly< double > Ellipse::property_center_y() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "center-y");
}

Glib::PropertyProxy< double > Ellipse::property_radius_x() 
{
  return Glib::PropertyProxy< double >(this, "radius-x");
}

Glib::PropertyProxy_ReadOnly< double > Ellipse::property_radius_x() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "radius-x");
}

Glib::PropertyProxy< double > Ellipse::property_radius_y() 
{
  return Glib::PropertyProxy< double >(this, "radius-y");
}

Glib::PropertyProxy_ReadOnly< double > Ellipse::property_radius_y() const
{
  return Glib::PropertyProxy_ReadOnly< double >(this, "radius-y");
}


} // namespace Goocanvas


